function [x,y,typ]=COMEDI_ENCODERIN_f(job,arg1,arg2)
  // Copyright 2002 Anders Blomdell
  //                Department of Automatic Control
  //                Lund Institute of Technology, Sweden
  x=[];y=[];typ=[]
  select job
  case 'plot' then
    arg1.graphics.gr_i=COMEDI_ENCODERIN_f('defaulticon', arg1);
    standard_draw(arg1)
  case 'getinputs' then
    [x,y,typ]=standard_inputs(arg1)
  case 'getoutputs' then
    [x,y,typ]=standard_outputs(arg1)
  case 'getorigin' then
    [x,y]=standard_origin(arg1)
  case 'set' then
    x=arg1;
    graphics=arg1.graphics;
    exprs=graphics.exprs;
    model=arg1.model;
    while %t do
      [ok,chan,exprs]=getvalue(..
	  ['Select Comedi ENCODERIN channels'],..
	  'Channels',..
	   list('vec',-1),exprs);
      if ~ok then 
        break //user cancel modification
      else 
        [model,graphics,ok]=check_io(model,graphics,[],size(chan,'*'),1,[]);
        if ok then
          model.ipar=chan';
	  model.dstate=zeros(size(model.ipar, 'r')*7,1);
	  x.model=model;
    	  graphics.exprs=exprs;
	  graphics.gr_i=COMEDI_ENCODERIN_f('defaulticon',arg1);
	  x.graphics=graphics;
          break
        end
      end
    end
  case 'define' then
    model=scicos_model();
    model.sim=list('comedi_encoderin',2);
    model.out=0;
    model.evtin=1;
    model.blocktype='d';
    model.dep_ut=[%f %f];
    exprs=[''];
    gr_i=['txt=[''COMEDI_ENCODERIN_f''];';
          'xstringb(orig(1),orig(2),txt,sz(1),sz(2),''fill'')']
    x=standard_define([4 2],model,exprs,gr_i);
  case 'defaulticon' then
    // Blatant hack to define icon in one place only
    // and make old diagrams be updated
    if stripblanks(arg1.model.label) ~= '' then
      label=arg1.model.label
    else
      label=['Encoder in';'[<chan>]'];
    end
    label = strsubst(label,'<chan>',strcat(' '+string(arg1.model.ipar))+' ');
    txt=strcat(''''+label+''';')
    txt='['+part(txt,[1:length(txt)-1])+']'
    x=['xstringb(orig(1),orig(2),'+txt+',sz(1),sz(2),''fill'')'];
  end
endfunction
